#include <cstdio>

int N;
int ploca[ 8 ][ 8 ];
int obrisan[ 8 ][ 8 ], minObrisan[ 8 ][ 8 ];
int minBr = 64;

int redZn[ 8 ][ 10 ] = { 0 };
int stuZn[ 8 ][ 10 ] = { 0 };

void rek( int d, int br )
{
	if( br >= minBr )
		return;
	
	if( d == N*N )
	{
		// pogledaj duplice u recima/stupcima
		for( int r = 0; r < N; ++r )
			for( int zn = 0; zn < 9; ++zn )
				if( redZn[ r ][ zn ] > 1 )
					return;
		
		for( int s = 0; s < N; ++s )
			for( int zn = 0; zn < 9; ++zn )
				if( stuZn[ s ][ zn ] > 1 )
					return;
		
		// pogledaj jel uzima susjede
		for( int r = 0; r < N; ++r )
			for( int s = 0; s < N; ++s )
			{
				if( r > 0 && obrisan[ r ][ s ] && obrisan[ r-1 ][ s ] )
					return;
					
				if( s > 0 && obrisan[ r ][ s ] && obrisan[ r ][ s-1 ] )
					return;
			}

		// pogledaj jel najbolje dosad
		if( br < minBr )
		{
			minBr = br;
			for( int r = 0; r < N; ++r )
				for( int s = 0; s < N; ++s )
					minObrisan[ r ][ s ] = obrisan[ r ][ s ];
		}
		
		return;
	}
	
	obrisan[ d%N ][ d/N ] = 0;
	++redZn[ d%N ][ ploca[ d%N ][ d/N ] ];
	++stuZn[ d/N ][ ploca[ d%N ][ d/N ] ];
	rek( d+1, br );
	--redZn[ d%N ][ ploca[ d%N ][ d/N ] ];
	--stuZn[ d/N ][ ploca[ d%N ][ d/N ] ];
	
	obrisan[ d%N ][ d/N ] = 1;
	rek( d+1, br+1 );
}


int main( void )
{
	scanf( "%d", &N );

	for( int r = 0; r < N; ++r )
		for( int s = 0; s < N; ++s )
			scanf( "%d", &ploca[ r ][ s ] );
		
	rek( 0, 0 );	
			
	for( int r = 0; r < N; ++r )
		for( int s = 0; s < N; ++s )
			if( minObrisan[ r ][ s ] )
				printf( "*%c", s == N-1 ? '\n' : ' ' );
			else
				printf( "%d%c", ploca[ r ][ s ], s == N-1 ? '\n' : ' ' );
			
	return 0;
}
