program warp;

var n : longint;
	words : array [0..100] of string;
	reverse : boolean;
	res : ansistring;

procedure input;
	var yns : string;
		f : longint;
begin
	readln(n);
	//setlength(words, n);
	for f := 0 to n - 1 do begin
		readln(words[f]);
	end;
	readln(yns);
	reverse := (yns = 'DA');
end;

function reverse_word(var w : string) : string;
	var sol : string;
		bi, ei : longint;
		tmp : char;
begin
	sol := w;
	bi := 1;
	ei := length(sol);
	while bi < ei do begin
		tmp := sol[bi];
		sol[bi] := sol[ei];
		sol[ei] := tmp;
		inc(bi);
		dec(ei);
	end;
	exit(sol);
end;

function compute_overlap(var w : string; var res : ansistring) : longint;
	var rcp, col : longint;
begin
	rcp := length(res);
	col := length(w);
	if col > rcp then begin
		col := rcp;
	end;
	while col > 0 do begin
		if copy(res, rcp - col + 1, col) = copy(w, 1, col) then begin
			exit(col);
		end;
		dec(col);
	end;
	exit(0);
end;

function compare_words(var oldw : string; var neww : string; var res : ansistring) : boolean;
	var o1, o2, l1, l2 : longint;
begin
	o1 := compute_overlap(oldw, res);
	o2 := compute_overlap(neww, res);
	if o1 > o2 then exit(false);
	if o1 < o2 then exit(true);
	l1 := length(oldw);
	l2 := length(neww);
	if l1 > l2 then exit(false);
	if l1 < l2 then exit(true);
	exit(oldw > neww);
end;

function best_match_index(n : longint; var words : array of string; var used : array of boolean; var res : ansistring; reverse : boolean) : longint;
	var f, bind : longint;
begin
	bind := -1;
	for f := 0 to n - 1 do begin
		if not used[f] then begin
			if (bind < 0) or (compare_words(words[bind], words[f], res)) then begin
				bind := f;
			end;
		end;
	end;
	if reverse then begin
		for f := 0 to n - 1 do begin
			if not used[f] then begin
				if (bind < 0) or (compare_words(words[bind], words[n + f], res)) then begin
					bind := n + f;
				end;
			end;
		end;
	end;
	exit(bind);
end;

procedure compute;
	var used : array [0..200] of boolean;
		f, znj, bind, ovl : longint;
begin
	if reverse then begin
		//setlength(words, 2 * n);
		for f := 0 to n - 1 do begin
			words[n + f] := reverse_word(words[f]);
		end;
	end;
	//setlength(used, n);
	for f := 0 to n - 1 do begin
		used[f] := false;
	end;
	res := words[0];
	used[0] := true;
	for znj := 1 to n - 1 do begin
		bind := best_match_index(n, words, used, res, reverse);
		ovl := compute_overlap(words[bind], res);
		res := res + copy(words[bind], ovl + 1, length(words[bind]) - ovl);
		if bind >= n then begin
			bind := bind - n;
		end;
		used[bind] := true;
	end;
end;

procedure output;
begin
	writeln(length(res));
	writeln(res);
end;

begin
	input;
	compute;
	output;
 readln;
end.
